/**
  *  \file client/widgets/searchobj.h
  *  \brief Search Query Object Selector
  *
  *  (c) 2001-2015 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_SEARCHOBJ_H
#define PCC_V2_CLIENT_WIDGETS_SEARCHOBJ_H

#include "ui/listbox.h"

/** Search Query Object Selector.
    Permits the user to select a set of objects to search for. */
class WSearchObjectSelector : public UIListbox {
 public:
    WSearchObjectSelector(int id);
    ~WSearchObjectSelector();

    void     setObjects(uint16_t objs);
    uint16_t getObjects() const;

    void     drawPart(GfxCanvas& can, int from, int to);
    bool     handleEvent(const UIEvent& event, bool second_pass);
    void     onItemClick(int item, int x);

 private:
    void     onToggle();

    uint16_t objs;
};

#endif
