/**
  *  \file int/if/plugif.h
  */
#ifndef PCC_V2_INT_IF_PLUGIF_H
#define PCC_V2_INT_IF_PLUGIF_H

#include "int/args.h"
#include "int/context.h"

class IntPluginContext : public IntContext {
 public:
    IntPluginContext(const string_t& id);
    ~IntPluginContext();

    virtual int32_t lookup(const string_t& name);
    virtual void set(int32_t index, IntValue* value);
    virtual IntValue* get(int32_t index);
    virtual bool next();
    virtual IntContext* clone();
    virtual GObject* getObject();
    virtual void enumProperties(IntPropertyAcceptor& acceptor);

    // IntValue:
    string_t toString(bool readable);
    void store(IntTagNode& sv, Stream& aux);

    const string_t& getId()
        { return id; }

 private:
    string_t id;
};

enum IntPluginProperty {
    ipiId,
    ipiName,
    ipiDescription,
    ipiBaseDirectory
};

IntValue* IFSystemPlugin(IntArgBlock& args);

IntValue* getPluginProperty(const string_t& id, IntPluginProperty ipi);

#endif
